; +-------------------+
; |  ShiftGround 1.1  |
; /////////////////////
;
; Cette routine remplit le
; sol avec une texture 16*16.
;
; Date   : 23/05/2003
; Taille : 170 octets
; Auteur : Guillaume H.
; <guillaume.h@ifrance.com>
;
;
; Entres:
; ix->sprite 16*16
; h=x |\
;     | [coin suprieur gauche]
; l=y |/
;
; b=distance entre le bord
; suprieur et l'objet de rfrence
; * a l'cran *
;
; c=dcalage horizontal voulu
; entre le bord suprieur et
; l'objet de rfrence
; +-> si c<0 : dcale  gauche
; +-> si c>0 : dcale  droite
;
; Sortie:
; * sol XOR dans le graph buffer
; * tous les registres dtruits
;   (sauf registres fantmes)

shftgrnd:
	push	hl

; a priori, on dcale  droite
	ld	a,14h
	ld	(inc_dec_d_SMC),a

;:::Calcul du rapport vertical:::
	ld	h,b ; cart  l'cran
	ld	a,48 ; cart absolu
; pourrait tre modifi par SMC

	ld	l,0
	bcall(_divHLbyA)
	ld	a,l
	ld	(rapport_vert),a

;:::Calcul du rapport horizontal:::
	ld	a,c
	or	a
	jp	p,calc_r_horiz

; pour dire qu'on dcale  gauche
	ld	hl,inc_dec_d_SMC
	inc	(hl)

	neg
; maintenant a=|c|
calc_r_horiz:
	ld	h,b
; H=cart  l'cran

	add	a,b
; A=cart  l'cran + dcalage

	ld	l,0
	bcall(_divHLbyA)
	ld	a,l
	ld	(rapport_horiz),a
;:::fin des calculs des rapports:::

	pop	hl

	ld	a,16
	ld	(compt),a

	dec	a
; a = 15 = %00001111

	and	h
	ld	(_sv_dec_h),a
; amorce le dcalage horizontal

	ld	e,l
	ld	h,0
	ld	d,h
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	de,gbuf
	add	hl,de

	ld	(sav_sprt),ix

	ld	bc,0

	jr	aff_ligne

shftgrnd_loop:

rapport_vert = $ + 1
	ld	a,0
	add	a,c
	ld	c,a
	jr	z,aff_ligne
	jr	c,aff_ligne

; si on n'affiche pas la ligne,
; on saute  la ligne suivante :
	inc	ix
	inc	ix

; pour revenir au dbut de la
; texture au cas o :
	call	reprend_texture
	jr	saute_ligne

compt:		.db	0
sav_sprt:	.dw	0

reprend_texture:
	ld 	a,(compt)
	dec	a
	ld	(compt),a
	ret	nz
	ld	a,16
	ld	(compt),a
	ld	ix,(sav_sprt)
	ret

aff_ligne:

_sv_dec_h = $ + 1
	ld	d,0

bcle_d_h:
rapport_horiz = $ + 1	
	ld	a,0
	add	a,b
	ld	b,a
	jr	z,fin_decalages
	jr	c,fin_decalages

; D stocke le dcalage horizontal
inc_dec_d_SMC:
	inc	d
; inc d <-> 14h | dec d <-> 15h

	jr	bcle_d_h

;:::fin des dcalages:::
fin_decalages:
	ld	a,d
	and	%00001111
	ld	(_sv_dec_h),a
; sauve le dcalage horizontal
; pour la prochaine ligne

	push	bc

	ld	d,(ix)	\ inc	ix
	ld	e,(ix)	\ inc	ix
	or	a
	jr	z,saute_dec_2o
	ld	b,a
rrc_DE_B_fois: ; merci joe p.!
	xor	a
	srl	d
	rr	e
	rra
	or	d
	ld	d,a
	djnz	rrc_DE_B_fois
saute_dec_2o:
	ld	b,6
bcle_ligne:
	ld	(hl),d \ inc	hl
	ld	(hl),e \ inc	hl
	djnz	bcle_ligne
; on a rempli une ligne d'cran

	pop	bc

	call	reprend_texture

saute_ligne:
	ld	de,gbuf+768
	ex	de,hl
	sbc	hl,de
; "or d" a teint le carry flag

	ret	z

	ex	de,hl
	jr	shftgrnd_loop
